package com.sbh.background_locations.receivers

import android.content.BroadcastReceiver
import android.content.Context
import android.content.Intent
import com.sbh.background_locations.LocationUpdatesService
import com.sbh.background_locations.callbacks.SBHProviderCallback

class ProviderChangeReceiver : BroadcastReceiver() {

    private var callback: SBHProviderCallback? = null

    fun setCallback(callback: SBHProviderCallback?) {
        this.callback = callback
    }

    override fun onReceive(context: Context, intent: Intent) {
        val enabled = intent.getBooleanExtra(LocationUpdatesService.EXTRA_PROVIDER_ENABLED, false)
        val status = intent.getIntExtra(LocationUpdatesService.EXTRA_PROVIDER_STATUS, 3)
        val gps = intent.getBooleanExtra(LocationUpdatesService.EXTRA_PROVIDER_GPS, false)
        val network = intent.getBooleanExtra(LocationUpdatesService.EXTRA_PROVIDER_NETWORK, false)
        callback?.onProviderChange(mapOf("enabled" to enabled, "status" to status, "gps" to gps, "network" to network))
    }
}