package com.sbh.background_locations.streams

import android.annotation.SuppressLint
import android.util.Log
import com.sbh.background_locations.BackgroundLocation
import com.sbh.background_locations.callbacks.SBHProviderCallback
import io.flutter.plugin.common.EventChannel

class ProviderChangeStreamHandler : StreamHandler(), SBHProviderCallback, EventChannel.StreamHandler {
    private val TAG = "ProviderChangeStreamHandler"

    init {
        mEvent = BackgroundLocation.EVENT_PROVIDER_CHANGE
    }

    @SuppressLint("LongLogTag")
    override fun onListen(args: Any?, eventSink: EventChannel.EventSink) {
        super.onListen(args, eventSink)
        Log.d(TAG, "PROVIDER CHANGE STREAM IS LISTENING")
        BackgroundLocation.getInstance(mActivity).onProviderChange(this)
    }

    override fun onProviderChange(data: Any) {
        mEventSink?.success(data)
    }

    override fun onError(error: Int) {
        mEventSink?.error(error.toString(), null, null)
    }
}